<!-- ERP 产品库存列表 -->
<template>

  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="auto"
    >
      <el-form-item :label="t('ErpStock.Stock.product')" prop="productId">
        <el-select
          v-model="queryParams.productId"
          clearable
          filterable
          :placeholder="t('ErpStock.Stock.placeholderProduct')"
          class="!w-240px"
        >
          <el-option
            v-for="item in productList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>

      <el-form-item :label="t('ErpStock.Stock.warehouse')" prop="warehouseId">
        <el-select
          v-model="queryParams.warehouseId"
          clearable
          filterable
          :placeholder="t('ErpStock.Stock.placeholderWarehouse')"
          class="!w-240px"
        >
          <el-option
            v-for="item in warehouseList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> {{ t('common.query') }}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> {{ t('common.reset') }}</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['erp:stock:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> {{ t('action.add') }}
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['erp:stock:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> {{ t('action.export') }}
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <!-- <el-tabs v-model="activeName" @tab-click="handleTabClick">
      <el-tab-pane label="产品" name="2" />
      <el-tab-pane label="原料" name="1" />
      <el-tab-pane label="备件" name="5" />
      <el-tab-pane label="工具" name="3" />
      <el-tab-pane label="耗材" name="4" />
      <el-tab-pane label="其他" name="0" />
    </el-tabs> -->
    <el-tabs v-model="activeName" @tab-click="handleTabClick">
      <!-- 使用 v-for 动态生成 el-tab-pane -->
    <el-tab-pane
      v-for="item in parentList"
      :key="item.id"
      :label="item.name"
      :name="item.id.toString()"
    />
    </el-tabs>
    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
      row-key="id"
      @selection-change="handleSelectionChange"
    >
      <el-table-column width="30" :label="t('action.select')" type="selection" />
      <el-table-column :label="t('ErpStock.Stock.code')" align="left" sortable prop="barCode" />
      <el-table-column :label="t('ErpStock.Stock.name')" align="left" sortable prop="productName" />
      <el-table-column :label="t('ErpStock.Stock.category')" align="center" prop="categoryName" />
      <el-table-column :label="t('ErpStock.Stock.unit')" align="center" prop="unitName" />
      <el-table-column
        :label="t('ErpStock.Stock.count')"
        align="right"
        sortable
        prop="count"
        :formatter="erpCountTableColumnFormatter"
      />

      <el-table-column :label="t('ErpStock.Stock.warehouse')" align="center" prop="warehouseName" />
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>
</template>

<script setup lang="ts">
import download from '@/utils/download'
import { StockApi, StockVO } from '@/api/erp/stock/stock'
import { ProductApi, ProductVO } from '@/api/erp/product/product'
import { WarehouseApi, WarehouseVO } from '@/api/erp/stock/warehouse'
import { erpCountTableColumnFormatter } from '@/utils'
import { ProductCategoryApi, ProductCategoryVO } from '@/api/erp/product/category'
import { handleTree } from '@/utils/tree'
/** ERP 产品库存列表 */
defineOptions({ name: 'ErpStock' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<StockVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  productId: undefined,
  warehouseId: undefined,
  categoryId: undefined
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const productList = ref<ProductVO[]>([]) // 产品列表
const warehouseList = ref<WarehouseVO[]>([]) // 仓库列表
const categoryList = ref<ProductCategoryVO[]>([]) // 产品分类列表
const parentList = ref<ProductCategoryVO[]>([])

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await StockApi.getStockPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await StockApi.deleteStock(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const ids = selectionList.value.map((item) => item.id).filter((v) => v != null)
    const params = {
      ...queryParams,
      ids: ids.length ? ids.join(',') : undefined
    }
    const data = await StockApi.exportStock(params)
    download.excel(data, t('ErpStock.Stock.exportName'))
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 选中操作 */
const selectionList = ref<StockVO[]>([])
const handleSelectionChange = (rows: StockVO[]) => {
  selectionList.value = rows
}

/** 初始化 **/
onMounted(async () => {
  queryParams.categoryId = 2
  await getList()
  // 加载产品、仓库列表
  productList.value = await ProductApi.getProductSimpleList()
  warehouseList.value = await WarehouseApi.getWarehouseSimpleList()
  // 产品分类
  const categoryData = await ProductCategoryApi.getProductCategorySimpleList()
  categoryList.value = handleTree(categoryData, 'id', 'parentId')
  // 获取顶层分类
  for (let i = 0; i < categoryData.length; i++) {
    if (categoryData[i].parentId === 0) {
      parentList.value.push(categoryData[i]);
    }
  }
  // 排序
  parentList.value.sort((a, b) => a.sort - b.sort);
})

/** tab 切换 */
let activeName = '2'
const handleTabClick = (tab: TabsPaneContext) => {
  queryParams.categoryId = tab.paneName
  handleQuery()
}
</script>
